# Makefile options

# targets: 
#     gpmain: the main program only (default)
#     dir:   the directory structure
#     clean_: clean the objects
#     all:    library and main program
#     libs:   only the libraries

# It's necesary to set the correct values to GPMAIN_DIR, METIS_DIR and BIN_DIR,
# and to fill ONELEM with the corresponding .o values

#GPMAIN_DIR = $(PAR_GPFEP_DIR)/src/main
GPMAIN_DIR=.
BIN_DIR=$(GPMAIN_DIR)/bin

ONELEM  = $(ODIR)/nselemplus.o \
 $(ODIR)/bcfemco.o \
 $(ODIR)/surelem.o \
 $(ODIR)/nssurf.o \
 $(ODIR)/nsbs.o \
 $(ODIR)/transp.o \
 $(ODIR)/kelem.o \
 $(ODIR)/derivut.o \
 $(ODIR)/epselem.o \
 $(ODIR)/lmm.o \
 $(ODIR)/ddx.o \
 $(ODIR)/ddy.o \
 $(ODIR)/ddz.o \
 $(ODIR)/fracvolex.o \
 $(ODIR)/fracvol.o \
 $(ODIR)/discomp.o \
 $(ODIR)/nutelem.o \
 $(ODIR)/telem.o \
 $(ODIR)/surtelem.o \
 $(ODIR)/pmpt.o \
 $(ODIR)/inicon.o  

CFLAGS=-Wall $(USER_INCLUDE)
FPPFLAGS=$(USER_INCLUDE)
FFLAGS=$(USER_INCLUDE)
#FFLAGS=$(USER_INCLUDE) -o $*.o
#FFLAGS=-ffixed-line-length-0
#FFLAGS=-qfixed=100
VERSION=2.3
BASE_DIR=$(PAR_GPFEP_DIR)
LOCDIR=$(GPMAIN_DIR)
HDIR=$(BASE_DIR)/src/par_gpfep/headers
ODIR=$(GPMAIN_DIR)/obj/$(P_ARCH)
#ODIR=.
SDIR=$(BASE_DIR)/src/par_gpfep
GPFEP_DIR=$(BASE_DIR)/src/gpfep
GPLIB_DIR=$(BASE_DIR)/lib/$(P_ARCH)
PAR_GPLIB_DIR=$(GPLIB_DIR)
USER_INCLUDE=-I$(HDIR)
PROF= 
HEADERS= 
SOURCES= 

OBJMAIN=$(ODIR)/gpmain.o
EXE=bin/gpmain_$(P_ARCH)

$(EXE): $(GPLIB_DIR)/libgpfep.a $(PAR_GPLIB_DIR)/libpar_gpfep.a \
       $(OBJMAIN) $(ONELEM)
	-$(FLINKER) -o $(EXE) $(OBJMAIN) $(ONELEM) \
	-L$(PAR_GPLIB_DIR) -L$(GPLIB_DIR) \
	-lpar_gpfep -lgpfep \
	$(PETSC_FORTRAN_LIB) $(PETSC_LIB) -lz

$(ODIR)/nselemplus.o: nselemplus.F int_nselem.f

# femcocfg.for
$(OBJMAIN): gpmain.F cfgreading.f

libs:
	(cd $(USER_LIB_DIR_MAK); make )
	(cd $(SDIR); make)
#	(cd $(PARTITION_DIR);  make)

clean_:
	rm $(ODIR)/*.o

cleanall: clean_
	(cd $(SDIR); make clean_)

all:  libs gpmain 

dir:
	mkdir $(GPMAIN_DIR)/libg
	mkdir $(GPMAIN_DIR)/libO
	mkdir $(GPMAIN_DIR)/libg/$(P_ARCH)
	mkdir $(GPMAIN_DIR)/libO/$(P_ARCH)
	(cd $(SDIR); make dir)

$(PAR_GPLIB_DIR)/libpar_gpfep.a:  
	(cd $(SDIR); make) 

$(GPLIB_DIR)/libgpfep.a:
	(cd $(GPFEP_DIR); make)

include $(PETSC_DIR)/lib/petsc/conf/variables
include $(PETSC_DIR)/lib/petsc/conf/rules
